<?php

namespace Drupal\monster_menus\Plugin\SyncNormalizerDecorator;


use Drupal\content_sync\Plugin\SyncNormalizerDecoratorBase;
use Drupal\Core\Entity\ContentEntityInterface;

/**
 * Provides a decorator for copying node permissions to/from an exported entity.
 *
 * @SyncNormalizerDecorator(
 *   id = "mm_node_permissions",
 *   name = @Translation("Copy MM node permissions"),
 * )
 */
class MMNodePermissions extends SyncNormalizerDecoratorBase {

  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
  }

  /**
   * @inheritDoc
   */
  public function decorateNormalization(array &$normalized_entity, ContentEntityInterface $entity, $format, array $context = []) {
    foreach (['groups_w', 'users_w', 'others_w'] as $field) {
      $normalized_entity[$field] = $entity->{$field};
    }
  }

  /**
   * @inheritDoc
   */
  public function decorateDenormalizedEntity(ContentEntityInterface $entity, array $normalized_entity, $format, array $context = []) {
    foreach (['groups_w', 'users_w', 'others_w'] as $field) {
      $entity->{$field} = $normalized_entity[$field];
    }
  }

}
